export default class Semaphore {

  private counter: number;
  private readonly maxLocks: number;
  constructor(maxLocks = -1) {
    this.counter = 0;
    this.maxLocks = maxLocks;
  }

  public lock(): boolean {
    if (this.counter < this.maxLocks || this.maxLocks === -1) {
      this.counter++;
      return true;
    }
    return false;
  }
  public unlock(): void {
    this.counter--;
    if (this.counter < 0) {
      this.reset();
    }
  }

  // TODO: Improve performance by integrating with Vue reactivity
  public locked(): boolean {
    return this.counter > 0;
  }

  public reset(): void {
    this.counter = 0;
  }
}
